config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  get 'password_resets/new'

  get 'password_resets/edit'

  get 'sessions/new'

  get '/help',      to: 'static_pages#help'
  get '/signup',    to: 'users#new'
  post '/signup',   to: 'users#create'
  get '/login',     to: 'sessions#new'
  post '/login',    to: 'sessions#create'
  delete '/logout', to: 'sessions#destroy'
  put '/tts',       to: 'users#tts'

  resources :dictionaries do
    collection do
      post 'export_multiple'
    end
    post 'export', on: :member
    resources :entries do
      member do
        post 'finalize'
        post 'play'
        get 'play'
      end
    end
  end
  resources :sampas
  resources :users
  resources :account_activations, only: [:edit]
  resources :password_resets, only: %i[new create edit update]

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root 'dictionaries#index'
end

app/models/dictionary.rb
class Dictionary < ApplicationRecord
  validates :name, presence: true
  validates :sampa, presence: true
  after_save :import_csv

  has_many :entries, dependent: :nullify, autosave: true
  belongs_to :sampa

  has_one_attached :import_data
  validates :import_data, attached: true
  has_one_attached :export_data

  # Bulk import all entries as CSV
  def import_csv
    return if attachment_changes['import_data'].nil?

    all_entries = array_of_records
    Entry.insert_all all_entries
  end

  def array_of_records
    user_id = Current.user.id
    now = Time.current
    records = []
    phonemes = sampa.phonemes.split
    CSV.read(attachment_changes['import_data'].attachable,
             headers: true, col_sep: "\t").each do |record|
      records << extract_(record, user_id, now, phonemes)
    end
    records
  end

  def extract_(record, user_id, now, phonemes)
    {
       word: record[0],
       sampa: record[1] || '',
       pos: record[2],
       dialect: record[3] || 'all',
       is_compound: record[4] || false,
       comp_part: record[5] || 'none',
       prefix: record[6] || false,
       lang: record[7] || 'IS',
       finished: record[8] || false,
       comment: record[9] || '',
       user_id: user_id,
       dictionary_id: id,
       created_at: now,
       updated_at: now,
       warning: !sampa_correct?(record[1], phonemes)
    }
  end

  def sampa_correct?(sampa, phonemes)
    return false if sampa.nil?

    phonemes.size.positive? ? (sampa.split - phonemes).size.zero? : true
  end
end

app/models/sampa.rb
# frozen_string_literal: true

include ::SampasConcern

class Sampa < ApplicationRecord
  validates :name, presence: true
  validates :phonemes, presence: true
  validates_with SampaValidator

  before_validation :fill_phonemes

  has_one_attached :attachment
  has_many :dictionaries, dependent: :nullify

  def fill_phonemes
    return if attachment_changes['attachment'].nil?

    # XXX DS: this is a hack! Because of some undefined reason, we cannot access the uploaded
    # file _officially_ before the model is saved to DB. So we use the metadata available in
    # the depths of ActiveStorage to get this information indirectly and load the file into memory.
    # But how would it make sense, to make the transformation of the uploaded
    # data into a model attribute _after_ the validation phase of the model has already been run ?
    # Here ActiveStorage is really inflexible.
    content = File.read(attachment_changes['attachment'].attachable)

    # the phoneme lists are newline separated.
    # TODO: make a validation of the content and raise an appropriate error in case the minimal
    #       format cannot be found
    self.phonemes = content.split(/\n/).uniq.join(' ')
  end
end

app/controllers/dictionaries_controller.rb
class DictionariesController < ApplicationController
  before_action :set_current_user
  before_action :set_dictionary, only: %i[show edit update destroy export]

  # GET /dictionaries
  # GET /dictionaries.json
  def index
    redirect_to help_path unless helpers.logged_in?
    @dictionaries = Dictionary.all
    # TODO: sort by name ? If we hide sortable metadata per dictionary in the views html,
    #       the frontend can make the sorting itself, as this view so far is not paginated
  end

  # GET /dictionaries/1
  # GET /dictionaries/1.json
  def show
    @word = params[:word] || '%'
    @sampa = params[:sampa] || '%'
    @comment = params[:comment] || '%'
    @only_warnings = params[:only_warnings] || false

    @sel_entries = @dictionary.entries.with_word(@word).with_sampa(@sampa)
                              .with_comment(@comment).ordered
    @sel_entries = @sel_entries.with_warning if @only_warnings

    @pagy, @entries = pagy(@sel_entries, count: @sel_entries.count)
    @entry_count = @dictionary.entries.size
    cookies[:dictionary_page] = @pagy.vars[:page]
  end

  # GET /dictionaries/new
  def new
    @dictionary = Dictionary.new
  end

  # GET /dictionaries/1/edit
  def edit; end

  # POST /dictionaries
  # POST /dictionaries.json
  def create
    @dictionary = Dictionary.new(dictionary_params)

    respond_to do |format|
      if @dictionary.save
        format.html { redirect_to @dictionary, notice: 'Dictionary was successfully created.' }
        format.json { render :show, status: :created, location: @dictionary }
      else
        format.html { render :new }
        format.json { render json: @dictionary.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /dictionaries/1
  # PATCH/PUT /dictionaries/1.json
  def update
    respond_to do |format|
      p = dictionary_params
      sampa = Sampa.find_by_id(p[:sampa_id])
      p[:sampa] = sampa
      if @dictionary.update(p.except(:sampa_id))
        format.html { redirect_to @dictionary }
        format.json { render :show, status: :ok, location: @dictionary }
      else
        format.html { render :edit }
        format.json { render json: @dictionary.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /dictionaries/1
  # DELETE /dictionaries/1.json
  def destroy
    @dictionary.destroy
    respond_to do |format|
      format.html { redirect_to dictionaries_url, notice: 'Dictionary was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  # Exports dictionary as CSV file
  def export
    all_entries = @dictionary.entries.all.load
    respond_to do |format|
      format.html { send_data gen_as_csv(all_entries), filename: "#{@dictionary.name}.csv" }
      format.json { head :no_content }
    end
  end

  # Exports multiple dictionaries as CSV file
  def export_multiple
    dictionary_ids = params[:dictionary_ids]
    unless dictionary_ids
      respond_to do |format|
        format.html { redirect_to dictionaries_url, notice: 'No Dictionary was selected' }
        format.json { head :no_content }
        return
      end
    end
    @dictionaries = Dictionary.find(dictionary_ids)

    all_entries = @dictionaries.each_with_object([]) do |dict, obj|
      obj.concat dict.entries.all.load
    end
    respond_to do |format|
      format.html do
        send_data gen_as_csv(all_entries), filename: "dictionaries_#{dictionary_ids.join('_')}.csv"
      end
      format.json { head :no_content }
      format.js { render inline: 'location.reload();' }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_dictionary
    @dictionary = Dictionary.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def dictionary_params
    params.require(:dictionary).permit(:name, :edited, :sampa_id, :dictionary_id,
                                       :import_data, :word, :sampa, :comment, :only_warnings,
                                       :is_final, :locale)
  end

  def gen_as_csv(entries)
    CSV.generate('', headers: true, col_sep: "\t") do |csv|
      csv << %w[WORD SAMPA POS PRON_VARIANT IS_COMPOUND COMPOUND_ATTR HAS_PREFIX LANG IS_VALIDATED COMMENT]
      entries.each do |e|
        is_validated = e.finished && !e.warning || false
        csv << [e.word.strip, e.sampa.strip, e.pos, e.dialect, e.is_compound, e.comp_part,
                e.prefix, e.lang, is_validated, e.comment.strip]
      end
    end
  end

  def set_current_user
    redirect_to help_path unless helpers.logged_in?
    Current.user = helpers.current_user
  end
end

app/helpers/dictionaries_helper.rb
require 'csv'

module DictionariesHelper
  # Returns if given entry's SAMPA is correct according to the Sampa associated to the dictionary
  # In case there is no such association, returns always true
  def sampa_correct?(entry)
    if @dictionary.sampa.nil?
      true
    else
      all_phonemes = @dictionary.sampa.phonemes.split
      entry_phonemes = entry.sampa.split
      (entry_phonemes.uniq - all_phonemes).empty?
    end
  end
end

app/views/dictionaries/_form.html.erb
<%= form_with(model: dictionary, local: true) do |form| %>
  <% if dictionary.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(dictionary.errors.count, "error") %> prohibited this dictionary from being saved:</h2>

      <ul>
        <% dictionary.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label t(:Name) %>
    <%= form.text_field :name %>
  </div>
  <%= form.collection_select(:sampa_id, Sampa.order(:name), :id, :name,
                             {prompt: t('Select SAMPA list'), selected: @dictionary.sampa}, { class: 'form-control'})%>

  <%= form.file_field :import_data, :multipart => true %>

  <div class="actions">
    <%= form.submit %>
  </div>

<% end %>

app/views/dictionaries/edit.html.erb
<h2>Editing Dictionary</h2>

<%= render 'form', dictionary: @dictionary %>

<%= link_to t('Show'), @dictionary %> |
<%= link_to t('Back'), :back %>

app/views/dictionaries/index.html.erb
<h2><%= t('Dictionaries') %></h2>

<%= form_tag export_multiple_dictionaries_path, method: :post do %>

<table class="table dictionaries">
  <thead>
    <tr>
      <th scope="col"><%= t('Name') %>    </th>
      <th scope="col"><%= t('Entries') %></th>
      <th scope="col"></th>
      <th scope="col"></th>
      <th data-sort-ignore="true"><input type="checkbox" id="selectAll"/><%= t('Select all')%> </th>
    </tr>
  </thead>

  <tbody>
    <% @dictionaries.each do |dictionary| %>
      <tr>
        <td><%= link_to "#{dictionary.name}", dictionary %></td>
        <td><%= dictionary.entries.count %></td>
        <td><%= link_to t('Edit'), edit_dictionary_path(dictionary) %></td>
        <td><%= link_to t('Destroy'), dictionary, method: :delete, data: { confirm: t('Are you sure?') } %></td>
        <td><%= check_box_tag "dictionary_ids[]", dictionary.id, false, class: 'selectable' %></td>
      </tr>
    <% end %>
  <tr>
    <td>
      <%= link_to t('New Dictionary'), new_dictionary_path, :class => 'btn btn-primary btn-xs' %>
    </td>
    <td></td>
    <td></td>
    <td></td>
      <td><%= submit_tag t('Export selected'), :class => 'btn btn-primary btn-xs', data: { disable_with: false } %></td>
  </tr>
  </tbody>
</table>

<% end %>

app/views/dictionaries/new.html.erb
<h2><%= t('New Dictionary') %></h2>

<%= render 'form', dictionary: @dictionary %>

<%= link_to 'Back', :back %>

app/views/dictionaries/show.html.erb
<div class="filter-trigger">
  <button id="filterTrigger" title="Toggle filter">
  <svg viewBox="0 0 16 16" >
    <path fill-rule="evenodd" d="M6 10.5a.5.5 0 01.5-.5h3a.5.5 0 010 1h-3a.5.5 0 01-.5-.5zm-2-3a.5.5 0 01.5-.5h7a.5.5 0 010 1h-7a.5.5 0 01-.5-.5zm-2-3a.5.5 0 01.5-.5h11a.5.5 0 010 1h-11a.5.5 0 01-.5-.5z" clip-rule="evenodd"/>
  </svg>
  </button>
</div>
<div class="main-filter" >
  <%= form_with(url: dictionary_path(@dictionary), method: "get", local: true) do %>
    <div class="row">
      <div class="form-group col-lg-3">
      <label><%= t('Word') %></label>
        <%= text_field_tag :word, @word,  class:'form-control'%>
      </div>
      <div class="form-group col-lg-3">
        <label><%= t('Sampa') %></label>
        <%= text_field_tag :sampa, @sampa,  class:'form-control' %>
      </div>
      <div class="form-group col-lg-3">
      <label><%= t('Comment') %></label>
          <%= text_field_tag :comment, @comment, class:'form-control'%>
      </div>
       <div class="form-group -checkbox col-lg-3">
        <%= check_box_tag :only_warnings, true, @only_warnings %>
        <%= label_tag :only_warnings, t('With warnings') %>
      </div>
      <div class="col-lg-12">
        <%= submit_tag t('Filter'), class: "btn btn-primary" %>
      </div>
   </div>
  <% end %>
</div>
 
<div class="word-table">
  <div class="text-sm-right dictionary-info">
    <%= t('Dictionary') %>:
    <strong><%= @dictionary.name %>,</strong>
    <span> <%= t('Showing') %> </span>
    <% if @sel_entries.size == @entry_count %>
      <strong><%= "#{@sel_entries.size}" %></strong><span> <%= t('entries') %></span>
    <% else %>
      <strong><%= @sel_entries.size %></strong> <span><%= t('filtered of overall') %></span> <strong><%= @entry_count %></strong><span> <%= t('entries') %></span>
    <% end %>
  </div>
  <div class="divTableHeading">
    <div class="divTableRow">
      <div class="divTableHead"><%= t('Word') %></div>
      <div class="divTableHead"><%= t('SAMPA') %></div>
    </div>
  </div>
  <div class="divTableBody" id="dictionaryEntries">
    <% @entries.each do |entry| %>
      <%= content_tag :div, class: 'entry', id: dom_id(entry) do %>
        <%= render entry %>
      <% end %>
    <% end %>
  </div>
</div>

<%== pagy_bootstrap_nav(@pagy) %>